#ifndef HASH_FUNC_H_INCLUDED
#define HASH_FUNC_H_INCLUDED

/* One-At-A-Time hash, see http://burtleburtle.net/bob/hash/doobs.html */ 

#define HASH_BEGIN(HASH)      \
  do {                        \
    (HASH) = 0;               \
  } while (0)
#define HASH_ADD(HASH, BYTE)  \
  do {                        \
    (HASH) += (BYTE);         \
    (HASH) += ((HASH) << 10); \
    (HASH) ^= ((HASH) >> 6);  \
  } while (0)
#define HASH_FINISH(HASH)     \
  do {                        \
    (HASH) += ((HASH) << 3);  \
    (HASH) ^= ((HASH) >> 11); \
    (HASH) += ((HASH) << 15); \
  } while (0)



#endif /* HASH_FUNC_H_INCLUDED */ 
